=== debian/changelog ===
zeekctl (2.2.0+ds1-2) experimental; urgency=medium

  * Add Breaks/Replaces broctl (Closes: #978939)
  * Update dependencies for default-mta

 -- Hilko Bengen <bengen@debian.org>  Fri, 01 Jan 2021 12:46:07 +0100

zeekctl (2.2.0+ds1-1) experimental; urgency=medium

  * New upstream version 2.2.0+ds1
  * Add git-buildpackage configuration
  * Update Files-Excluded line in debian/copyright

 -- Hilko Bengen <bengen@debian.org>  Thu, 31 Dec 2020 02:24:28 +0100

zeekctl (2.1.0+ds1-1) experimental; urgency=medium

  * New upstream version 2.1.0+ds1
  * Rename pacakge bro -> zeek, update packaging
  * Update watch file; filter aux/* from upstream tarballs
  * Remove Raúl Benencia from Uploaders, per his request

 -- Hilko Bengen <bengen@debian.org>  Sun, 31 May 2020 19:21:12 +0200

broctl (1.9-1) unstable; urgency=medium

  * New upstream version 1.9
  * Update watch file
  * Bump Debhelper compat level
  * Replace dh_install --fail-missing
  * Update Vcs-* headers after migration to salsa.debian.org
  * Bump Standards-Version

 -- Hilko Bengen <bengen@debian.org>  Mon, 24 Dec 2018 22:39:40 +0100

broctl (1.4-1) unstable; urgency=medium

  * New upstream version
  * Remove unneeded patches
  * Define BRO_{SPOOL,LOG}_DIR
  * No longer create documentation files by running parts of broctl
  * Update Build-Depends, Depends

 -- Hilko Bengen <bengen@debian.org>  Fri, 30 Oct 2015 23:33:09 +0100

broctl (1.3-1) unstable; urgency=low

  * Initial release (Closes: #771143)

 -- Raúl Benencia <rul@kalgan.cc>  Fri, 06 Feb 2015 14:17:40 -0300
