=== debian/control ===
Source: zeekctl
Section: net
Priority: optional
Maintainer: Hilko Bengen <bengen@debian.org>
Build-Depends: cmake, debhelper (>= 11),
 dh-python,
 python3,
 python3-subnettree,
 zeek,
 capstats,
 trace-summary,
 default-mta | mail-transport-agent,
Standards-Version: 4.3.0
Homepage: http://www.zeek.org
Vcs-Git: https://salsa.debian.org/bro-team/zeekctl.git
Vcs-Browser: https://salsa.debian.org/bro-team/zeekctl

Package: zeekctl
Architecture: all
Depends: zeek, capstats, trace-summary,
 default-mta | mail-transport-agent,
 ${misc:Depends},
 ${python3:Depends},
Breaks: broctl (<< 2~)
Replaces: broctl (<< 2~)
Description: interactive shell for managing Zeek installations
 Zeek is primarily a security monitor that inspects all traffic on a
 link in depth for signs of suspicious activity. More generally,
 however, Zeek supports a wide range of traffic analysis tasks even
 outside of the security domain, including performance measurements
 and helping with trouble-shooting.
 .
 This package contains zeekctl, an interactive shell for managing Zeek
 installations.
