=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@  --buildsystem=cmake --with=python3

override_dh_auto_configure:
	dh_auto_configure -- \
	-DZEEK_SCRIPT_INSTALL_PATH=/usr/share/zeek \
	-DZEEK_ETC_INSTALL_DIR=/etc/zeek \
	-DZEEK_SPOOL_DIR=/var/spool/zeek \
	-DZEEK_LOG_DIR=/var/log/zeek

override_dh_missing:
	dh_missing --fail-missing
