=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/,\
     dversionmangle=s/\+dfsg\d*$//,\
     uversionmangle=s/$/+ds1/ \
  https://download.zeek.org/ (?:bro|zeek)ctl-(\d.*)\.tar\.gz
